Page MenuHomePhabricator

AMC: add history link to actions menu
Closed, ResolvedPublic8 Story Points

Description

User story

As an experienced editor, I would like the ability to reach the history of an article quicker, so that I can monitor the changes made to the article.

Design

The history icon will appear in the toolbar for AMC users. This is (hopefully) a comprehensive overview of possible toolbar states:

default+download+map gadget+download, +map gadgetuser page
AMC off
AMC on

Future design considerations

These ideas aren't fully flushed out, but there are a few things we may want to aim for in the future:

  • the ability to specify primary/secondary icons, so that more important actions don't get displaced by less important ones
  • the ability to specify the sequence of the first and last item in the toolbar, such that we can always know that Languages shows up first, and Edit shows up last (not counting the "More" action).
  • the ability to add labels next to icons for larger screens
  • the ability to do something special with the languages icon, e.g. include a label even on smaller screens
toolbar system
special languages treatment

Acceptance criteria

  • Add history link to toolbar of pages in all namespaces where History exists (when user is in AMC mode)
  • Clicking history will navigate to the mobile version of the history page
  • In AMC mode the three right-most icons should always be: download, watch, history, edit (in that order, with edit being the furthest right)
  • In non-AMC mode the two right-most icons should always be: download, watch, edit (in that order, with edit being the furthest right)
  • The history link should be feature flagged a la wgMinervaTalkAtTop - it should be possible to turn it on and off in AMC mode. (To be confirmed by developer)
  • There should be no visible changes to non-AMC mode (at least for now) to avoid problems with cached HTML.

QA

Test on the beta cluster.
Testing Cached HTML: Our changes went live in wmf/1.33.0-wmf.20, so we'll want to test against HTML in wmf19 and 20.

Test on the beta cluster:

  • Test on AMC (mobile)
  • Test on AMC Tablet
  • Test on non-AMC tablet

Test cached HTML and check for an absence of visual regresions

Descoped QA

Test with map gadget on

@ovasileva QA of integration in the map gadget will require a QA task of its own. We need to first enable the maps gadget on the beta cluster by copying across https://en.wikipedia.org/wiki/MediaWiki:Gadgets-definition to https://en.wikipedia.beta.wmflabs.org/wiki/MediaWiki:Gadgets-definition#admin - I am not an admin of beta cluster so we'll need help from Release Engineering to do this.

With Map gadget enabled:

  • Test on AMC (mobile) (AC1)
  • Test on AMC Tablet (AC2)
  • Test on non-AMC tablet (AC3)

Sign off steps

  • Did we accrue any tech debt here that we need to pay off? If so create a card to make sure this gets addressed.
  • Create signoff task for map gadget with descoped QA instructions above
  • Document inconsistent behavior for history link (link appears for pages do not exist)

QA Results

ACStatusDetails))
1.1✅ PassedT213352#5028939
1.2✅ PassedT213352#5028939
1.3❌ FailT213352#5028939
1.4✅ PassedT213352#5028939
1.5✅ PassedT213352#5028939
1.6✅ PassedT213352#5028939
2.1✅ PassedT213352#5028939
2.2✅ PassedT213352#5028939
2.3❌ FailT213352#5028939
2.4✅ PassedT213352#5028939
2.5✅ PassedT213352#5028939
2.6✅ PassedT213352#5028939
3.1⬜ NAT213352#5028939
3.2⬜ NAT213352#5028939
3.3⬜ NAT213352#5028939
3.4⬜ NAT213352#5028939
3.5✅ PassedT213352#5028939
3.6✅ PassedT213352#5028939

QA Results: Production

ACESARIDDetails))
1.1T213352#5051272
1.2T213352#5051272
1.3T213352#5051272
1.4T213352#5051272
1.5T213352#5051272
1.6T213352#5051272
2.1T213352#5051272
2.2T213352#5051272
2.3T213352#5051272
2.4T213352#5051272
2.5T213352#5051272
2.6T213352#5051272
3.1NANANAT213352#5051272
3.2NANANAT213352#5051272
3.3NANANAT213352#5051272
3.4NANANAT213352#5051272
3.5T213352#5051272
3.6T213352#5051272

Event Timeline

There are a very large number of changes, so older changes are hidden. Show Older Changes

Change 493415 had a related patch set uploaded (by Jdrewniak; owner: Jdrewniak):
[mediawiki/skins/MinervaNeue@master] Add history icon to page actions menu for AMC mode

https://gerrit.wikimedia.org/r/493415

Change 492001 merged by jenkins-bot:
[mediawiki/skins/MinervaNeue@master] Refactor pageActions menu to accommodate AMC mode

https://gerrit.wikimedia.org/r/492001

hey @alexhollender , I've submitted a patch with the requested changes, including the mechanism that changes the layout to "equally spaced" if there are 5 or more items.

However, there is a problem :(

Something that I did not anticipate is that, because extra items are loaded via javascript (i.e. download/share etc.) , that means they are inserted after pageload. That means that the initial layout is parsed as only have 4 items, and then it changes rather abruptly when the extra items are inserted.

I have a video showing this effect.
https://drive.google.com/file/d/10GguWhX2WXQC5U-whE04xvWy_k80gvuk/view?usp=sharing

As you can see, the pageload occurs quite late in the game (especially on long articles).

documenting a conversation @Jdrewniak and I had offline. It seems like we may largely avoid the awkwardness loading situation, at least for now, because the following default cases will not be affected by it:

AMC off (iOS)AMC off (Android)AMC on (iOS/Android)

the cases that will be affected by it are where there are 5 icons in the toolbar (because that's when the icons switch to equal spacing), and one (or more) of them is being loaded via Javascript. Examples are:

  • AMC off, Android, map gadget and/or Share beta on (image)
  • AMC off, iOS, map gadget and Share beta on

An alternative we could try out would be the non-equal spacing approach:

After speaking with @Jdrewniak a bit more, we think the best course of action is to continue using the current toolbar layout for now, which means there will be no jumping icons. With the addition of the history icon AMC users will see:

iOSAndroidAndroid w/ map

@ovasileva @Jdlrobson @Jdrewniak shall I update the task description?

We generated some ideas for how to better handle the jumping icon stuff, and hope to have something figured out by the time we get around to introducing the overflow/more menu, so we can switch to our awesome, new, equally spaced icon toolbar.

After speaking with @Jdrewniak a bit more, we think the best course of action is to continue using the current toolbar layout for now, which means there will be no jumping icons. With the addition of the history icon AMC users will see:

iOSAndroidAndroid w/ map

@ovasileva @Jdlrobson @Jdrewniak shall I update the task description?

Sounds good

alexhollender updated the task description. (Show Details)Mar 6 2019, 8:19 PM
alexhollender removed Jdrewniak as the assignee of this task.

Looks good to me. Here is what I'm seeing on staging:

AMC onAMC off
iOS (phone)
iOS (tablet)
Android (phone)

Change 493415 merged by jenkins-bot:
[mediawiki/skins/MinervaNeue@master] Add history icon to page actions menu for AMC mode

https://gerrit.wikimedia.org/r/493415

Change 495067 had a related patch set uploaded (by Jdrewniak; owner: Jdrewniak):
[mediawiki/skins/MinervaNeue@master] Add config option for showing history link in page actions menu

https://gerrit.wikimedia.org/r/495067

Change 495067 merged by jenkins-bot:
[mediawiki/skins/MinervaNeue@master] Add config option for showing history link in page actions menu

https://gerrit.wikimedia.org/r/495067

Test Result

Status: In Progress
OS: macOS Mojave
Browser: Chrome DevTools Device Emulator (iPhone X $ iPad Pro)

Test Artifact(s):

  • Test on AMC (mobile) (with map gadget on and off)

    Add history link to toolbar of pages in all namespaces where History exists (when user is in AMC mode)

    Clicking history will navigate to the mobile version of the history page

    If a page does not have a history page, do not display history icon

    In AMC mode the three left-most icons should always be: edit, history, watch (in that order, with edit being the furthest left)

    In non-AMC mode the two left-most icons should always be: edit, watch (in that order, with edit being the furthest left)

    The history link should be feature flagged a la wgMinervaTalkAtTop - it should be possible to turn it on and off in AMC mode.

    There should be no visible changes to non-AMC mode (at least for now) to avoid problems with cached HTML.
  • Test on AMC Tablet (with map gadget on and off)

    Add history link to toolbar of pages in all namespaces where History exists (when user is in AMC mode)

    Clicking history will navigate to the mobile version of the history page

    If a page does not have a history page, do not display history icon

    In AMC mode the three left-most icons should always be: edit, history, watch (in that order, with edit being the furthest left)

    In non-AMC mode the two left-most icons should always be: edit, watch (in that order, with edit being the furthest left)

    The history link should be feature flagged a la wgMinervaTalkAtTop - it should be possible to turn it on and off in AMC mode.

    There should be no visible changes to non-AMC mode (at least for now) to avoid problems with cached HTML.
  • Test on non-AMC tablet (with map gadget on and off)


    Add history link to toolbar of pages in all namespaces where History exists (when user is in AMC mode) : NA

    Clicking history will navigate to the mobile version of the history page : NA

    If a page does not have a history page, do not display history icon : NA

    In AMC mode the three left-most icons should always be: edit, history, watch (in that order, with edit being the furthest left): Should this be rightmost?

    In non-AMC mode the two left-most icons should always be: edit, watch (in that order, with edit being the furthest left)Should this be rightmost?

    The history link should be feature flagged a la wgMinervaTalkAtTop - it should be possible to turn it on and off in AMC mode.

    There should be no visible changes to non-AMC mode (at least for now) to avoid problems with cached HTML. Pass
  • Test on cached HTML (mobile) (with map gadget on and off)

    Add history link to toolbar of pages in all namespaces where History exists (when user is in AMC mode)

    Clicking history will navigate to the mobile version of the history page

    If a page does not have a history page, do not display history icon

    In AMC mode the three left-most icons should always be: edit, history, watch (in that order, with edit being the furthest left)

    In non-AMC mode the two left-most icons should always be: edit, watch (in that order, with edit being the furthest left)

    The history link should be feature flagged a la wgMinervaTalkAtTop - it should be possible to turn it on and off in AMC mode.

    There should be no visible changes to non-AMC mode (at least for now) to avoid problems with cached HTML.
  • Test on cached HTML tablet (with map gadget on and off)

    Add history link to toolbar of pages in all namespaces where History exists (when user is in AMC mode)

    Clicking history will navigate to the mobile version of the history page

    If a page does not have a history page, do not display history icon

    In AMC mode the three left-most icons should always be: edit, history, watch (in that order, with edit being the furthest left)

    In non-AMC mode the two left-most icons should always be: edit, watch (in that order, with edit being the furthest left)

    The history link should be feature flagged a la wgMinervaTalkAtTop - it should be possible to turn it on and off in AMC mode.

    There should be no visible changes to non-AMC mode (at least for now) to avoid problems with cached HTML.
Edtadros added a subscriber: Edtadros.

@Jdlrobson I have a few questions:

  1. Testing on Cached HTML: There used to be a flag I could set in Chrome to reload cached pages. I'm assuming that's what this means. But that flag is no longer present. Is there some other way to test this?
  2. The mag gadget: I assume it should have shown up on the Qatar page. Does this gadget appear by default on pages that deal with geographic subjects? Do I need to be logged in or set any preference?
  3. The icons specify left most....do you mean right-most. I'm starting to question right and left now.
  4. How can I check the feature flag?

hey @Edtadros , I don't think I know of a simple way to test using cached HTML, but 2, 3, 4:

  1. The map gadget - you have to be logged in to wikipedia, then (on desktop) under preferences -> gadgets -> check "Add map popups to coordinates in the mobile website" - then switch to mobile, and pages with locations should have the gadget.
  2. Yes, right-most :)
  3. I think this can be checked by a developer on a local machine, since it involves changes a MediaWiki config file and seeing if the change takes effect.
Jdrewniak updated the task description. (Show Details)Mar 11 2019, 9:28 PM
Jdlrobson updated the task description. (Show Details)

Fleshed out these. I suggest we do not test the map gadget as part of this change, cc @ovasileva

Fleshed out these. I suggest we do not test the map gadget as part of this change, cc @ovasileva

Sounds good - I'll add creating the separate QA task to the signoff criteria here.

ovasileva updated the task description. (Show Details)Mar 13 2019, 9:43 AM
Edtadros added a comment.EditedMar 16 2019, 1:32 AM

Test Results

Status: In Progress
OS: macOS Mojave
Browser: Chrome DevTools Device Emulator (iPhone X and iPad)

Test Artifact(s):

Test on AMC (mobile)

AC1.1:PASS
Add history link to toolbar of pages in all namespaces where History exists (when user is in AMC mode)

AC1.2:PASS
Clicking history will navigate to the mobile version of the history page

❌ - Navigated to: http://readingwebstaging.wmflabs.org/wiki/Special:History/Qatar Page shows error. Failing this for now.

✅ Retested on 3/19/2019: http://readingwebstaging.wmflabs.org/wiki/Amc_test_me

AC1.3:FAIL
If a page does not have a history page, do not display history icon

❌ History Icon was displayed but the history page appears to not exist.

❌ Retested on 3/19/2019: http://readingwebstaging.wmflabs.org/wiki/User:Edtadros The history link still shows. This time on the far left.


AC1.4:PASS
In AMC mode the three right-most icons should always be: edit, history, watch (in that order, with edit being the furthest left)

❌ - Order appears to be reversed.

✅ Retested on 3/19/2019: QA steps updated

AC1.5:PASS
In non-AMC mode the two right-most icons should always be: edit, watch (in that order, with edit being the furthest left)

❌ - Order appears to be reversed.

✅ Retested on 3/19/2019: QA steps updated

AC1.6:PASS
There should be no visible changes to non-AMC mode (at least for now) to avoid problems with cached HTML.

Test on AMC Tablet

AC2.1:PASS
Add history link to toolbar of pages in all namespaces where History exists (when user is in AMC mode)

AC2.2:PASS
Clicking history will navigate to the mobile version of the history page:

❌ Navigated to: http://readingwebstaging.wmflabs.org/wiki/Special:History/Qatar Page shows error. Failing this for now.

✅ Retested on 3/19/2019: This works now

AC2.3:FAIL
If a page does not have a history page, do not display history icon
❌ History Icon was displayed but the history page appears to not exist.

❌ Retested on 3/19/2019: This is still failing

AC2.4:PASS
In AMC mode the three right-most icons should always be: edit, history, watch (in that order, with edit being the furthest left):

❌ Order appears to be reversed.

✅ Retested on 3/19/2019: QA steps updated

AC2.5:PASS
In non-AMC mode the two right-most icons should always be: edit, watch (in that order, with edit being the furthest left):

❌ - Order appears to be reversed.

✅ Retested on 3/19/2019: QA steps updated

AC2.6:PASS
There should be no visible changes to non-AMC mode (at least for now) to avoid problems with cached HTML.

Test on non-AMC tablet

AC3.1:NA
Add history link to toolbar of pages in all namespaces where History exists (when user is in AMC mode)

AC3.2:NA
Clicking history will navigate to the mobile version of the history page

AC3.3:NA
If a page does not have a history page, do not display history icon

AC3.4:NA
In AMC mode the three right-most icons should always be: edit, history, watch (in that order, with edit being the furthest left)

AC3.5:PASS
In non-AMC mode the right left-most icons should always be: edit, watch (in that order, with edit being the furthest left)


❌ - Order appears to be reversed.

✅ Retested on 3/19/2019: QA steps updated

AC3.6:PASS
There should be no visible changes to non-AMC mode (at least for now) to avoid problems with cached HTML.

@Jdlrobson A few errors here T213352#5028939, some I suspect are just typos in the test steps. A question about the third set of criteria. Testing in non-AMC mode. To me, it seems the applicable steps/criteria are already covered by the "Test on AMC Tablet" criteria...am I missing something?

A couple of notes on the acceptance criteria (will fix in the description):

  • In AMC mode the three right-most icons should always be: edit, history, watch (in that order, with edit being the furthest left) - this is incorrect. Edit is always furthest right.
  • In non-AMC mode the two right-most icons should always be: edit, watch (in that order, with edit being the furthest left) - edit is always furthest right
ovasileva updated the task description. (Show Details)Mar 18 2019, 11:24 AM

@Edtadros Test on page (http://readingwebstaging.wmflabs.org/wiki/Amc_test_me). All acceptance criteria met except Clicking history will navigate to the mobile version of the history page. Leaving in needs more work.

Test on AMC tablet, non-AMC tablet, AMC mobile

  • Add history link to toolbar of pages in all namespaces where History exists (when user is in AMC mode)

PASS

  • Clicking history will navigate to the mobile version of the history page

FAIL - it's navigating to the desktop version

  • If a page does not have a history page, do not display history icon

PASS - tested on contributions page, watchlist


  • In AMC mode the three right-most icons should always be: download, watch, history, edit (in that order, with edit being the furthest right)

PASS see screenshots above

  • In non-AMC mode the two right-most icons should always be: download, watch, edit (in that order, with edit being the furthest left)

PASS

  • There should be no visible changes to non-AMC mode (at least for now) to avoid problems with cached HTML.

PASS - see screenshots above

Test on beta cluster page https://en.m.wikipedia.beta.wmflabs.org/wiki/Dog. All acceptance criteria passed:

Test on AMC tablet, non-AMC tablet, AMC mobile

  • Add history link to toolbar of pages in all namespaces where History exists (when user is in AMC mode)

PASS

  • Clicking history will navigate to the mobile version of the history page

PASS

  • If a page does not have a history page, do not display history icon

PASS - tested on contributions page, watchlist


  • In AMC mode the three right-most icons should always be: download, watch, history, edit (in that order, with edit being the furthest right)

PASS see screenshots above

  • In non-AMC mode the two right-most icons should always be: download, watch, edit (in that order, with edit being the furthest left)

PASS

  • There should be no visible changes to non-AMC mode (at least for now) to avoid problems with cached HTML.

PASS - see screenshot above

Note: tested map gadget on wikis for deployment in T217643. The gadget is not available on Spanish, Arabic, or Indonesian Wikipedias. Testing the map gadget is not a blocker for this deployment. However, a followup task will be created and testing will be a blocker for future deployment to other Wikipedias.

Edtadros reassigned this task from Edtadros to ovasileva.Mar 20 2019, 5:13 AM

@ovasileva I tested in staging and beta and the behavior is the same in both. I updated T213352#5028939 but it's a bit cluttered. In a nutshell, the only thing that isn't passing is the history icon showing up on a page with no history. I used my user page to test this, so this may or may not be valid. The good news is that in both environments when I click on a valid history link it goes to the mobile history page.

@ovasileva I tested in staging and beta and the behavior is the same in both. I updated T213352#5028939 but it's a bit cluttered. In a nutshell, the only thing that isn't passing is the history icon showing up on a page with no history. I used my user page to test this, so this may or may not be valid. The good news is that in both environments when I click on a valid history link it goes to the mobile history page.

Good catch! I read this mostly as pages that couldn't possibly have a history page - but it makes sense - shouldn't show up for pages that don't exist yet.

ovasileva updated the task description. (Show Details)Mar 20 2019, 5:16 PM
ovasileva updated the task description. (Show Details)

Change 498051 had a related patch set uploaded (by Jdrewniak; owner: Jdrewniak):
[mediawiki/skins/MinervaNeue@master] Only show history link in page-actions menu if page exists

https://gerrit.wikimedia.org/r/498051

Change 498051 merged by jenkins-bot:
[mediawiki/skins/MinervaNeue@master] Only show history link in page-actions menu if page exists

https://gerrit.wikimedia.org/r/498051

Jdlrobson assigned this task to Edtadros.

If a page does not have a history page, do not display history icon: ❌ Fail

This one should pass now @Edtadros please test on https://en.m.wikipedia.beta.wmflabs.org/wiki/Spainsasasaassa
ttps://phabricator.wikimedia.org/T213352#5028939

Note: pages proxied from production will not show a history link
e.g. https://en.m.wikipedia.beta.wmflabs.org/wiki/Barcelona

Edtadros added a comment.EditedMar 23 2019, 10:30 PM

@Jdlrobson I may be doing something wrong. The link you gave redirects to the New_user_landing_page. I'm logged in with AMC on. See the attached video:

That page has history so I couldn't verify.

Edtadros updated the task description. (Show Details)Mar 23 2019, 10:37 PM
Edtadros updated the task description. (Show Details)Mar 23 2019, 10:42 PM
Edtadros updated the task description. (Show Details)EditedMar 24 2019, 1:50 AM

Test Results: Production

Status: In Progress
OS: iOS
Browser: Chrome (iPhoneXS Max and iPad Pro)

Test Artifact(s):

Test on AMC (mobile)

AC1.1:
Add history link to toolbar of pages in all namespaces where History exists (when user is in AMC mode)

eswiki: ✅arwiki: ✅idwiki: ✅

AC1.2:
Clicking history will navigate to the mobile version of the history page

eswiki: ✅arwiki: ✅idwiki: ✅

AC1.3:
If a page does not have a history page, do not display history icon

eswiki: ❌arwiki: ❌idwiki: ✅

AC1.4:
In AMC mode the three right-most icons should always be: watch, history, edit (in that order, with edit being the furthest right) *Reversed for arwiki

eswiki: ✅arwiki: ✅idwiki: ✅
see AC1.1see AC1.1see AC1.1

AC1.5:
In non-AMC mode the two right-most icons should always be: watch, edit (in that order, with edit being the furthest right) *Reversed for arwiki

eswiki: ✅arwiki: ✅idwiki: ✅

AC1.6:
There should be no visible changes to non-AMC mode (at least for now) to avoid problems with cached HTML.

eswiki: ✅arwiki: ✅idwiki: ✅

Test on AMC Tablet

AC2.1:
Add history link to toolbar of pages in all namespaces where History exists (when user is in AMC mode)

eswiki: ✅arwiki: ✅idwiki: ✅

AC2.2:
Clicking history will navigate to the mobile version of the history page:

eswiki: ✅arwiki: ✅idwiki: ✅

AC2.3:
If a page does not have a history page, do not display history icon

eswiki: ❌arwiki: ❌idwiki: ✅

AC2.4:
In AMC mode the three right-most icons should always be: watch, history, edit (in that order, with edit being the furthest right) *Reversed for arwiki

eswiki: ✅arwiki: ✅idwiki: ✅
see AC2.1see AC2.1see AC2.1

AC2.5:
In non-AMC mode the two right-most icons should always be: edit, watch (in that order, with edit being the furthest left):

eswiki: ✅arwiki: ✅idwiki: ✅

AC2.6:
There should be no visible changes to non-AMC mode (at least for now) to avoid problems with cached HTML.

eswiki: ✅arwiki: ✅idwiki: ✅

Test on non-AMC tablet

AC3.1:
Add history link to toolbar of pages in all namespaces where History exists (when user is in AMC mode)

eswiki: NAarwiki: NAidwiki: NA

AC3.2:
Clicking history will navigate to the mobile version of the history page

eswiki: NAarwiki: NAidwiki: NA

AC3.3:
If a page does not have a history page, do not display history icon

eswiki: NAarwiki: NAidwiki: NA

AC3.4:
In AMC mode the three right-most icons should always be: watch, history, edit (in that order, with edit being the furthest right) *Reversed for arwiki

eswiki: NAarwiki: NAidwiki: NA

AC3.5:
In non-AMC mode the right left-most icons should always be: edit, watch (in that order, with edit being the furthest left)

eswiki: ✅arwiki: ✅idwiki: ✅
see AC2.5see AC2.5see AC2.5

AC3.6:
There should be no visible changes to non-AMC mode (at least for now) to avoid problems with cached HTML.

eswiki: ✅arwiki: ✅idwiki: ✅
Edtadros updated the task description. (Show Details)Mar 24 2019, 1:59 AM
Edtadros updated the task description. (Show Details)Mar 24 2019, 2:18 AM
Edtadros updated the task description. (Show Details)Mar 24 2019, 2:32 AM

@Jdlrobson @ovasileva I'm getting hung up on the testing the pages with no history. I've labeled that acceptance criterion as AC1.3 and AC2.3 in T213352#5051272. For some odd reason it functions in idwiki but not eswiki or arwiki. I wasn't able to get the history icon to NOT show up if I had AMC ON even in beta https://en.m.wikipedia.beta.wmflabs.org/wiki/Spainsasasaassa (see T213352#5049388). Am I doing something wrong, or am I not understanding the requirement? I could use another pair of eyes on the idwiki "anomaly" where it appears to work.

Edtadros claimed this task.Apr 1 2019, 5:10 PM
Edtadros reassigned this task from Edtadros to ovasileva.Apr 4 2019, 12:09 AM

Test Results: Production

Status: In Progress
OS: iOS
Browser: Chrome (iPhoneXS Max and iPad Pro)

Test Artifact(s):

Test on AMC (mobile)

AC1.3:
If a page does not have a history page, do not display history icon

eswiki: ✅arwiki: ✅idwiki: ✅

Test on AMC Tablet

AC2.3:
If a page does not have a history page, do not display history icon

eswiki: ✅arwiki: ✅idwiki: ✅
ovasileva closed this task as Resolved.Apr 8 2019, 10:16 AM

All done! Thanks @Edtadros for all your work in QAing this one